<?php

namespace Xmlnuke\Core\Database;

/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2014-04-11 at 18:20:13.
 */
class BaseModelTest extends \PHPUnit_Framework_TestCase
{

	/**
	 * Sets up the fixture, for example, opens a network connection.
	 * This method is called before a test is executed.
	 */
	protected function setUp()
	{
	}

	/**
	 * Tears down the fixture, for example, closes a network connection.
	 * This method is called after a test is executed.
	 */
	protected function tearDown()
	{

	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::setPropertyPattern
	 */
	public function testSetPropertyPattern()
	{
		$object = new \Tests\Xmlnuke\Sample\BaseModel();

		$object->setPropertyPattern('/(.*)/', '$1');
		$this->assertEquals(array('/(.*)/', '$1'), $object->getPropertyPattern());

		$object->setPropertyPattern('(.*)', '$1');
		$this->assertEquals(array('/(.*)/', '$1'), $object->getPropertyPattern());
	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::setPropertyPattern
	 */
	public function testSetPropertyPatternNull()
	{
		$object = new \Tests\Xmlnuke\Sample\BaseModel();
		$object->setPropertyPattern(null, null);

		$this->assertEquals(null, $object->getPropertyPattern());
	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindObject
	 */
	public function testGetPropertyPattern()
	{
		$object = new \Tests\Xmlnuke\Sample\BaseModel();

		$this->assertEquals(array('/([^A-Za-z0-9])/', ''), $object->getPropertyPattern());
	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindArray
	 */
	public function testBindSingleRow()
	{
		$sr = new \Xmlnuke\Core\AnyDataset\SingleRow();
		$sr->AddField("id", 10);
		$sr->AddField("name", "Testing");

		$object = new \Tests\Xmlnuke\Sample\BaseModel($sr);

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());
	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindArray
	 */
	public function testBindIterator()
	{
		$anydata = new \Xmlnuke\Core\AnyDataset\AnyDataSet();

		$sr = new \Xmlnuke\Core\AnyDataset\SingleRow();
		$sr->AddField("id", 10);
		$sr->AddField("name", "Testing");
		$anydata->appendRow($sr);

		$object = new \Tests\Xmlnuke\Sample\BaseModel($anydata->getIterator());

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());
	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindContext
	 */
	public function testBindFromContext()
	{
		$_REQUEST["id"] = 10;
		$_REQUEST["name"] = "Testing";
		$context = \Xmlnuke\Core\Engine\Context::getInstance();
		$context->set("id", 10);
		$context->set("name", "Testing");

		$object = new \Tests\Xmlnuke\Sample\BaseModel($context);

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());

	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindGeneralObject
	 */
	public function testBindFromObject()
	{
		$model = new \Tests\Xmlnuke\Sample\ModelGetter(10, 'Testing');

		$object = new \Tests\Xmlnuke\Sample\BaseModel($model);

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());
	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindStdClass
	 */
	public function testBindFromStdClass()
	{
		// Matching exact property names
		$model = new \stdClass();
		$model->Id = 10;
		$model->Name = "Testing";

		$object = new \Tests\Xmlnuke\Sample\BaseModel($model);

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());

		// Matching with different case letters
		$model2 = new \stdClass();
		$model2->id = 10;
		$model2->name = "Testing";

		$object = new \Tests\Xmlnuke\Sample\BaseModel($model2);

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());

	}

	/**
	 * @covers Xmlnuke\Core\Database\BaseModel::bindArray
	 */
	public function testBindFromArray()
	{
		$array = array(
			"Id" => 10,
			"Name" => "Testing"
		);

		$object = new \Tests\Xmlnuke\Sample\BaseModel($array);

		$this->assertEquals(10, $object->Id);
		$this->assertEquals("Testing", $object->getName());
	}

	public function testPropertyPatternBind()
	{
		$obj = new \stdClass();
		$obj->Id_Model = 10;
		$obj->Client_Name = 'Testing';

		// Testing Without Property Bind
		$object = new \Tests\Xmlnuke\Sample\ModelPropertyPattern();
		$object->setPropertyPattern(null, null);
		$object->bind($obj);

		$this->assertEquals('', $object->getIdModel());
		$this->assertEquals('', $object->getClientName());

		// Testing with Bind
		$object = new \Tests\Xmlnuke\Sample\ModelPropertyPattern();
		$object->bind($obj);

		$this->assertEquals(10, $object->getIdModel());
		$this->assertEquals("Testing", $object->getClientName());

		// Testing Constructor
		$object = new \Tests\Xmlnuke\Sample\ModelPropertyPattern($obj);

		$this->assertEquals(10, $object->getIdModel());
		$this->assertEquals("Testing", $object->getClientName());
	}


	public function testPropertyPatternBind_2()
	{
		// Other Testing
		$obj = new \stdClass();
		$obj->IdModel = 10;
		$obj->ClientName = 'Testing';

		$object = new \Tests\Xmlnuke\Sample\ModelPropertyPattern($obj);

		$this->assertEquals(10, $object->getIdModel());
		$this->assertEquals("Testing", $object->getClientName());
	}

}
